#include <dirent.h>     //DIR* __cdecl __MINGW_NOTHROW opendir (const char*);
            //struct dirent* __cdecl __MINGW_NOTHROW readdir (DIR*);
            //int __cdecl __MINGW_NOTHROW closedir (DIR*);
//#include <bits/stat.h>
#include <sys/stat.h>   //_CRTIMP int __cdecl __MINGW_NOTHROW  _stati64(const char *, struct _stati64 *);
#include <string.h>     //char * __cdecl strchr (const char * string, int ch)
#include <time.h>   //_CRTIMP char* __cdecl __MINGW_NOTHROW     ctime (const time_t*);

const int IS_DIR_FLAG = 1, IS_FILE_FLAG = 2;
 
static DIR *dirPointer;
struct dirent *next_entry;
struct stat64 statbuf_64; //struct _stati64 statbuf_64;
 
int MINGW_opendir (char * path) {
    dirPointer = opendir(path);
    if (dirPointer==NULL) return 0; //On error, NULL is returned,...
    return -1;
}
 
int MINGW_readdir (char* file_name, long long* file_size, int* flags, char* LastStatusChange, char* LastFileAccess, char* LastFileModification) {
    next_entry = readdir(dirPointer);
    if (next_entry==NULL) return 0;
    //https://man7.org/linux/man-pages/man3/readdir.3.html
    //struct dirent {
    //...
    //char d_name[256]; /* Null-terminated filename */
    //};

        stat64(next_entry->d_name, &statbuf_64);//_stati64(next_entry->d_name, &statbuf_64);
    //return strlen(next_entry->d_name);
    strcpy(file_name, next_entry->d_name);
    *file_size = statbuf_64.st_size;
    *flags = 0;
    if (S_ISDIR(statbuf_64.st_mode)) *flags = IS_DIR_FLAG;
    if (S_ISREG(statbuf_64.st_mode)) *flags = IS_FILE_FLAG;
    strcpy(LastStatusChange, ctime(&statbuf_64.st_ctime));
    strcpy(LastFileAccess, ctime(&statbuf_64.st_atime));
    strcpy(LastFileModification, ctime(&statbuf_64.st_mtime));
}
 
int MINGW_closedir () {
    return closedir(dirPointer); // The closedir() function returns 0 on success.  On error, -1 is returned,...
}

//Function strchrKAZE~&& (ByVal buf1 As _Offset, Byval byteSOUGHT As integer)
uint64_t strchrKAZE (char * buf1, uint16_t byteSOUGHT)
{
return (uint64_t)(strchr(buf1, byteSOUGHT)-buf1);
}
//char * __cdecl strchr (const char * string, int ch)
//char *strchr(string, c) - search a string for a character
//
//Purpose:
//       Searches a string for a given character, which may be the
//       null character '\0'.
//
//Entry:
//       char *string - string to search in
//       char c - character to search for
//
//Exit:
//       returns pointer to the first occurence of c in string
//       returns NULL if c does not occur in string


/*
#if defined (__MSVCRT__)
struct _stati64 {
    _dev_t st_dev;
    _ino_t st_ino;
    _mode_t st_mode;
    short st_nlink;
    short st_uid;
    short st_gid;
    _dev_t st_rdev;
    __int64 st_size;
    time_t st_atime; //Accessed date
    time_t st_mtime; //Modified time
    time_t st_ctime; //Creation time
};
*/

/*
#if defined (__MSVCRT__)
#if __MSVCRT_VERSION__ < 0x0800
_CRTIMP int __cdecl __MINGW_NOTHROW  _fstati64(int, struct _stati64 *);
_CRTIMP int __cdecl __MINGW_NOTHROW  _stati64(const char *, struct _stati64 *);
*/
